class PushsController < ApplicationController
  include ActionController::HttpAuthentication::Token
  skip_before_action :verify_authenticity_token

  def token
    param! :app_name, String, required: true
    param! :app_id, String, required: true
    param! :app_secret, String, required: true

    app_setting = AppSettings.send(params[:app_name].to_sym) rescue {}
    if app_setting['app_id'] == params[:app_id] && app_setting['app_secret'] == params[:app_secret]
      render json: { code: 0, message: 'success', token: Token.generate_token(params[:app_name]), ttl: Token.ttl(params[:app_name])}
    else
      render json: { code: -1, message: '应用不存在或者app_id/app_secret不匹配'}
    end
  end

  # app_name 应用名称
  # user_device_ids 设备ids
  # message 推送信息的json 字符串
  # igetui_opts 个推推送的额外选项
  def push
    param! :app_name, String, required: true
    param! :device_ids_opts, String, required: true
    param! :message, String, required: true
    param! :igetui_opts, String

    igetui_opts = JSON.parse(params[:igetui_opts]) rescue {}
    message = JSON.parse(params[:message]) rescue {}
    device_ids_opts = JSON.parse(params[:device_ids_opts]) rescue {}
    token = token_and_options(request).first
    if token == Token.token(params[:app_name])
      ::PushWorker.perform_async(device_ids_opts, message, igetui_opts)
      render json: { code: 0, message: 'success', describe: '异步任务正在处理'}
    else
      render json: { code: -1, message: 'token 错误/过期'}
    end
  end
end
